/* 

L'utilisateur peut ajouter ici du code JavaScript et/ou p5.js 
(y compris avec utilisation du paradigme "objet").

Dans p5Visuel, on peut y accéder via les blocs "Commande p5" et "expression p5"

Par exemple si on définit (en dehors de ce commentaire) la fonction suivante

	function distance(x1,y1,x2,y2) {
		return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
	}

et si les variables 
	dist, a, b, c, d 
sont définies dans notre programme p5Visuel
alors, dans notre programme p5Visuel, on peut utiliser
	• le bloc "commande p5" avec le paramètre "dist=distance(a,b,c,d)"
	• le bloc "expression p5" avec le paramètre "distance(a,b,c,d)"
	
*/

var canevas, nbMaxMouvTortue, nbMouvTortue, gliss, para, vitesse, x, d, a, bouton, y, para2, texte, variable, i, bouton2;

/**
 * Décrire cette fonction…
 */
function init_environnement() {
  nbMaxMouvTortue = 0;
  para=createP('Vitesse = ');
  gliss=createSlider(0,60,1,1);
  gliss.parent(para);
  gliss.style('width','300px');
  bouton=createButton('Recommencer');
  bouton.mouseClicked(recommencer);
  bouton2=createButton('Une étape');
  bouton2.mouseClicked(une_etape);
  para2=createP('');
  frameRate(round(1));
}

/**
 * Fonction exécutée périodiquement, de façon répétée
 */
function actions_en_boucle() {
  if (fixer_vitesse()) {
    return ;
  }
  initialisationTortue(leGraphicsActif);nbMouvTortue = 0;
  figure();
  nbMaxMouvTortue = nbMaxMouvTortue + 1;
}

/**
 * Décrire cette fonction…
 */
function recommencer() {
  nbMaxMouvTortue = 0;
  gliss.value(1);
  para2.html("");
}

/**
 * Décrire cette fonction…
 */
function fixer_vitesse() {
  vitesse = traiterNombre(gliss.value());
  if (vitesse > 0) {
    frameRate(round(vitesse));
  }
  return vitesse == 0;
}

/**
 * Décrire cette fonction…
 */
function limite_nbMouv_atteinte() {
  nbMouvTortue = nbMouvTortue + 1;
  return nbMouvTortue >= nbMaxMouvTortue;
}

/**
 * Décrire cette fonction…
 */
function une_etape() {
  gliss.value(0);
  initialisationTortue(leGraphicsActif);if (nbMaxMouvTortue == 0) {
    nbMaxMouvTortue = 1;
  }
  nbMouvTortue = 0;
  figure();
  nbMaxMouvTortue = nbMaxMouvTortue + 1;
}

/**
 * Fonction exécutée une fois, au départ
 */
function actions_initiales() {
  initialisation();
  init_environnement();
}

/**
 * Décrire cette fonction…
 */
function Avance_(d) {
  if (limite_nbMouv_atteinte()) {
    return ;
  }
  avance(d);
  para2.html((String('Avance ') + String(d)));
}

/**
 * Décrire cette fonction…
 */
function Recule_(d) {
  if (limite_nbMouv_atteinte()) {
    return ;
  }
  recule(d);
  para2.html((String('Recule  ') + String(d)));
}

/**
 * Décrire cette fonction…
 */
function Droite_(a) {
  if (limite_nbMouv_atteinte()) {
    return ;
  }
  droite(a);
  para2.html((String('Droite ') + String(a)));
}

/**
 * Décrire cette fonction…
 */
function Gauche_(a) {
  if (limite_nbMouv_atteinte()) {
    return ;
  }
  gauche(a);
  para2.html((String('Gauche ') + String(a)));
}

/**
 * Décrire cette fonction…
 */
function Aller_(x, y) {
  if (limite_nbMouv_atteinte()) {
    return ;
  }
  fixePos(x,y);
  para2.html((['Aller (',x,' , ',y,' )'].join('')));
}

/**
 * Décrire cette fonction…
 */
function Sauter_(x, y) {
  if (limite_nbMouv_atteinte()) {
    return ;
  }
  sautePos(x,y);
  para2.html((['Sauter (',x,' , ',y,' )'].join('')));
}

/**
 * Décrire cette fonction…
 */
function Fixe_Cap_(a) {
  if (limite_nbMouv_atteinte()) {
    return ;
  }
  fixeCap(a);
  para2.html((String('Fixe cap ') + String(a)));
}

/**
 * Décrire cette fonction…
 */
function Avis_(texte, variable) {
  if (limite_nbMouv_atteinte()) {
    return ;
  }
  para2.html((String(texte) + String(variable)));
}


